/*
 *  linux/include/asm-arm/arch-pxa/lubbock.h
 *
 *  Author:	Nicolas Pitre
 *  Created:	Jun 15, 2001
 *  Copyright:	MontaVista Software Inc.
 *  
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.
 */

#define LUBBOCK_FPGA_PHYS	PXA_CS2_PHYS
#define LUBBOCK_FPGA_VIRT	(0xf0000000)	/* phys 0x08000000 */
#define LUBBOCK_ETH_PHYS	PXA_CS3_PHYS
#define LUBBOCK_ETH_VIRT	(0xf1000000)
#define LAN0_VIRT		(0xf1000000)
#define LAN1_VIRT		(0xf1100000)
#define LUBBOCK_SA1111_BASE	(0xf4000000)	/* phys 0x10000000 */

#define LUB_P2V(x)		((x) - LUBBOCK_FPGA_PHYS + LUBBOCK_FPGA_VIRT)
#define LUB_V2P(x)		((x) - LUBBOCK_FPGA_VIRT + LUBBOCK_FPGA_PHYS)

#ifndef __ASSEMBLY__
#  define __LUB_REG(x)		(*((volatile unsigned long *)LUB_P2V(x)))
#else
#  define __LUB_REG(x)		LUB_P2V(x)
#endif

/* FPGA register virtual addresses */
	
#define LUB_IRQ_GP1		(*((volatile unsigned char *)(0xf0000000))) 
#define LUB_IRQ_GP2		(*((volatile unsigned char *)(0xf0100000)))
#define LUB_IRQ_GP3		(*((volatile unsigned char *)(0xf0200000)))
#define LUB_VID			(*((volatile unsigned char *)(0xf0300000)))		

/* GPIOs */

#define GPIO_LUBBOCK_IRQ	2
#define IRQ_GPIO_LUBBOCK_IRQ	IRQ_GPIO(2)

#define PCMCIA_S0_RDYINT	IRQ_GPIO(21)

#define CF_S1_RDYINT		IRQ_GPIO(22)

#define PCC_IRQ(i)		(GPLR0 & (1<<(21+i)) ) 	

#define BUMP_COUNTER (HEXLEDS_BASE = hexled_val++)
#define DEC_COUNTER (HEXLEDS_BASE = hexled_val--)


