/*
 *  linux/include/asm-arm/arch-pxa/serial.h
 * 
 * Author:	Nicolas Pitre
 * Copyright:	(C) 2001 MontaVista Software Inc.
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.
 */


#define BAUD_BASE	921600
#define BAUD_BASE2	(14318000/14)

/* Standard COM flags */
#define STD_COM_FLAGS (ASYNC_SKIP_TEST)

#define STD_SERIAL_PORT_DEFNS	\
	{	\
		type:			PORT_XSCALE,	\
		xmit_fifo_size:		32,		\
		baud_base:		BAUD_BASE,	\
		iomem_base:		(void *)&FFUART,\
		iomem_reg_shift:	2,		\
		io_type:		SERIAL_IO_MEM,	\
		irq:			IRQ_FFUART,	\
		flags:			STD_COM_FLAGS,	\
	}, {	\
		type:			PORT_XSCALE,	\
		xmit_fifo_size:		32,		\
		baud_base:		BAUD_BASE,	\
		iomem_base:		(void *)&BTUART,\
		iomem_reg_shift:	2,		\
		io_type:		SERIAL_IO_MEM,	\
		irq:			IRQ_BTUART,	\
		flags:			STD_COM_FLAGS,	\
	}, {	\
		type:			PORT_XSCALE,	\
		xmit_fifo_size:		32,		\
		baud_base:		BAUD_BASE,	\
		iomem_base:		(void *)&STUART,\
		iomem_reg_shift:	2,		\
		io_type:		SERIAL_IO_MEM,	\
		irq:			IRQ_STUART,	\
		flags:			STD_COM_FLAGS,	\
	}, {	\
		type:			PORT_16750,	\
		xmit_fifo_size:		56,		\
		baud_base:		BAUD_BASE2,	\
		iomem_base:		(void *)0xf4200000,\
		iomem_reg_shift:	1,		\
		io_type:		SERIAL_IO_MEM,	\
		irq:			LUBBOCK_IRQ(8),	\
		flags:			STD_COM_FLAGS ,	\
	}, {	\
		type:			PORT_16750,	\
		xmit_fifo_size:		56,		\
		baud_base:		BAUD_BASE2,	\
		iomem_base:		(void *)0xf4300000,\
		iomem_reg_shift:	1,		\
		io_type:		SERIAL_IO_MEM,	\
		irq:			LUBBOCK_IRQ(9),	\
		flags:			STD_COM_FLAGS,	\
	}, {	\
		type:			PORT_16750,	\
		xmit_fifo_size:		56,		\
		baud_base:		BAUD_BASE2,	\
		iomem_base:		(void *)0xf4400000,\
		iomem_reg_shift:	1,		\
		io_type:		SERIAL_IO_MEM,	\
		irq:			LUBBOCK_IRQ(10),	\
		flags:			STD_COM_FLAGS, 	\
	}, {	\
		type:			PORT_16750,	\
		xmit_fifo_size:		56,		\
		baud_base:		BAUD_BASE2,	\
		iomem_base:		(void *)0xf4500000,\
		iomem_reg_shift:	1,		\
		io_type:		SERIAL_IO_MEM,	\
		irq:			LUBBOCK_IRQ(11),	\
		flags:			STD_COM_FLAGS,	\
	}, {	\
		type:			PORT_16750,	\
		xmit_fifo_size:		56,		\
		baud_base:		BAUD_BASE2,	\
		iomem_base:		(void *)0xf4600000,\
		iomem_reg_shift:	1,		\
		io_type:		SERIAL_IO_MEM,	\
		irq:			LUBBOCK_IRQ(12),	\
		flags:			STD_COM_FLAGS,	\
	}, {	\
		type:			PORT_16750,	\
		xmit_fifo_size:		56,		\
		baud_base:		BAUD_BASE2,	\
		iomem_base:		(void *)0xf4700000,\
		iomem_reg_shift:	1,		\
		io_type:		SERIAL_IO_MEM,	\
		irq:			LUBBOCK_IRQ(13),	\
		flags:			STD_COM_FLAGS,	\
	}, {	\
		type:			PORT_16750,	\
		xmit_fifo_size:		56,		\
		baud_base:		BAUD_BASE2,	\
		iomem_base:		(void *)0xf4800000,\
		iomem_reg_shift:	1,		\
		io_type:		SERIAL_IO_MEM,	\
		irq:			LUBBOCK_IRQ(14),	\
		flags:			STD_COM_FLAGS,	\
	}, {	\
		type:			PORT_16750,	\
		xmit_fifo_size:		56,		\
		baud_base:		BAUD_BASE2,	\
		iomem_base:		(void *)0xf4900000,\
		iomem_reg_shift:	1,		\
		io_type:		SERIAL_IO_MEM,	\
		irq:			LUBBOCK_IRQ(15),	\
		flags:			STD_COM_FLAGS,	\
	}

#define RS_TABLE_SIZE 12

#define EXTRA_SERIAL_PORT_DEFNS

